<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML3.2 EN">
<HTML>
<HEAD>
<META NAME="GENERATOR" CONTENT="DOCTEXT">
<TITLE>MatRegisterDynamic</TITLE>
</HEAD>
<BODY BGCOLOR="FFFFFF">
<A NAME="MatRegisterDynamic"><H1>MatRegisterDynamic</H1></A>
Adds a new matrix type 
<H3><FONT COLOR="#CC3333">Synopsis</FONT></H3>
<PRE>
PetscErrorCode MatRegisterDynamic(char *name,char *path,char *name_create,PetscErrorCode (*routine_create)(Mat))
</PRE>
Not Collective
<P>
<H3><FONT COLOR="#CC3333">Input Parameters</FONT></H3>
<TABLE border="0" cellpadding="0" cellspacing="0">
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>name </B></TD><TD>- name of a new user-defined matrix type
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>path </B></TD><TD>- path (either absolute or relative) the library containing this solver
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>name_create </B></TD><TD>- name of routine to create method context
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>routine_create </B></TD><TD>- routine to create method context
</TD></TR></TABLE>
<P>
<H3><FONT COLOR="#CC3333">Notes</FONT></H3>
<A HREF="../Mat/MatRegisterDynamic.html#MatRegisterDynamic">MatRegisterDynamic</A>() may be called multiple times to add several user-defined solvers.
<P>
If dynamic libraries are used, then the fourth input argument (routine_create)
is ignored.
<P>
<H3><FONT COLOR="#CC3333">Sample usage</FONT></H3>
<PRE>
   <A HREF="../Mat/MatRegisterDynamic.html#MatRegisterDynamic">MatRegisterDynamic</A>("my_mat",/home/username/my_lib/lib/libO/solaris/mylib.a,
               "MyMatCreate",MyMatCreate);
</PRE>

<P>
Then, your solver can be chosen with the procedural interface via
<pre>
    <A HREF="../Mat/MatSetType.html#MatSetType">MatSetType</A>(<A HREF="../Mat/Mat.html#Mat">Mat</A>,"my_mat")
</pre>
or at runtime via the option
<pre>
    -mat_type my_mat
</pre>
<P>

<P>
Notes: ${PETSC_ARCH} occuring in pathname will be replaced with appropriate values.
If your function is not being put into a shared library then use <A HREF="../Vec/VecRegister.html#VecRegister">VecRegister</A>() instead
<P>
<H3><FONT COLOR="#CC3333">Keywords</FONT></H3>
 <A HREF="../Mat/Mat.html#Mat">Mat</A>, register
<BR>
<P>
<H3><FONT COLOR="#CC3333">See Also</FONT></H3>
 <A HREF="../Mat/MatRegisterAll.html#MatRegisterAll">MatRegisterAll</A>(), <A HREF="../Mat/MatRegisterDestroy.html#MatRegisterDestroy">MatRegisterDestroy</A>()
<BR>
<P>
<P><B><P><B><FONT COLOR="#CC3333">Level:</FONT></B>advanced
<BR><FONT COLOR="#CC3333">Location:</FONT></B><A HREF="../../../src/mat/../../include/petscmat.h.html#MatRegisterDynamic">src/mat/../../include/petscmat.h</A>
<BR><A HREF="./index.html">Index of all Mat routines</A>
<BR><A HREF="../../index.html">Table of Contents for all manual pages</A>
<BR><A HREF="../singleindex.html">Index of all manual pages</A>
</BODY></HTML>
